// This file is generated by kconfig_compiler from directoryviewpropertysettings.kcfg.
// All changes you do to this file will be lost.
#ifndef VIEWPROPERTYSETTINGS_H
#define VIEWPROPERTYSETTINGS_H

#include <dolphinview.h>
#include <qnamespace.h>

#include <kglobal.h>
#include <kconfigskeleton.h>
#include <kdebug.h>

class ViewPropertySettings : public KConfigSkeleton
{
  public:

    ViewPropertySettings( KSharedConfig::Ptr config = KGlobal::config() );
    ~ViewPropertySettings();

    /**
      Set Show hidden files
    */
    void setShowHiddenFiles( bool v )
    {
      if (!isImmutable( QString::fromLatin1 ( "ShowHiddenFiles" ) ))
        mShowHiddenFiles = v;
    }

    /**
      Get Show hidden files
    */
    bool showHiddenFiles() const
    {
      return mShowHiddenFiles;
    }

    /**
      Set View Mode
    */
    void setViewMode( int v )
    {
      if (v < 0)
      {
        kDebug() << "setViewMode: value " << v << " is less than the minimum value of 0" << endl;
        v = 0;
      }

      if (v > DolphinView::MaxModeEnum)
      {
        kDebug() << "setViewMode: value " << v << " is greater than the maximum value of DolphinView::MaxModeEnum" << endl;
        v = DolphinView::MaxModeEnum;
      }

      if (!isImmutable( QString::fromLatin1 ( "ViewMode" ) ))
        mViewMode = v;
    }

    /**
      Get View Mode
    */
    int viewMode() const
    {
      return mViewMode;
    }

    /**
      Set Show preview
    */
    void setShowPreview( bool v )
    {
      if (!isImmutable( QString::fromLatin1 ( "ShowPreview" ) ))
        mShowPreview = v;
    }

    /**
      Get Show preview
    */
    bool showPreview() const
    {
      return mShowPreview;
    }

    /**
      Set Sort files by
    */
    void setSorting( int v )
    {
      if (v < 0)
      {
        kDebug() << "setSorting: value " << v << " is less than the minimum value of 0" << endl;
        v = 0;
      }

      if (v > DolphinView::MaxSortEnum)
      {
        kDebug() << "setSorting: value " << v << " is greater than the maximum value of DolphinView::MaxSortEnum" << endl;
        v = DolphinView::MaxSortEnum;
      }

      if (!isImmutable( QString::fromLatin1 ( "Sorting" ) ))
        mSorting = v;
    }

    /**
      Get Sort files by
    */
    int sorting() const
    {
      return mSorting;
    }

    /**
      Set Order to sort files in
    */
    void setSortOrder( int v )
    {
      if (v < Qt::Ascending)
      {
        kDebug() << "setSortOrder: value " << v << " is less than the minimum value of Qt::Ascending" << endl;
        v = Qt::Ascending;
      }

      if (v > Qt::Descending)
      {
        kDebug() << "setSortOrder: value " << v << " is greater than the maximum value of Qt::Descending" << endl;
        v = Qt::Descending;
      }

      if (!isImmutable( QString::fromLatin1 ( "SortOrder" ) ))
        mSortOrder = v;
    }

    /**
      Get Order to sort files in
    */
    int sortOrder() const
    {
      return mSortOrder;
    }

    /**
      Set Properties last changed
    */
    void setTimestamp( const QDateTime & v )
    {
      if (!isImmutable( QString::fromLatin1 ( "Timestamp" ) ))
        mTimestamp = v;
    }

    /**
      Get Properties last changed
    */
    QDateTime timestamp() const
    {
      return mTimestamp;
    }

  protected:

    // Settings
    bool mShowHiddenFiles;

    // Dolphin
    int mViewMode;
    bool mShowPreview;
    int mSorting;
    int mSortOrder;
    QDateTime mTimestamp;

  private:
};

#endif

